"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var TemplationComponent = (function () {
    function TemplationComponent(vr, cfr, compiler) {
        this.vr = vr;
        this.cfr = cfr;
        this.compiler = compiler;
        this.imports = null;
        this.template = null;
    }
    TemplationComponent.prototype.ngOnInit = function () {
        this.renderComponent();
    };
    TemplationComponent.prototype.renderComponent = function () {
        var _this = this;
        var hasTemplate = !!this.template;
        if (!this.component || !hasTemplate)
            return false;
        var templatedComponent = this.returnTemplatedComponent();
        var templationModule = this.returnTemplationModule({ templatedComponent: templatedComponent });
        this.compiler.compileModuleAndAllComponentsAsync(templationModule)
            .then(function (factory) {
            var compFactory = factory.componentFactories.find(function (x) { return x.componentType === templatedComponent; });
            var cmpRef = _this.vr.createComponent(compFactory, 0);
        });
    };
    // will be used to get dependecies from constructor of
    // parent class
    TemplationComponent.prototype.getDeps = function (func) {
        // First match everything inside the function argument parens.
        var args = func.toString().match(/function\s.*?\(([^)]*)\)/)[1];
        // Split the arguments string into an array comma delimited.
        return args.split(',').map(function (arg) {
            // Ensure no inline comments are parsed and trim the whitespace.
            return arg.replace(/\/\*.*\*\//, '').trim();
        }).filter(function (arg) {
            console.log('arg', arg);
            // Ensure no undefined values are added.
            return arg;
        });
    };
    TemplationComponent.prototype.returnTemplatedComponent = function () {
        var _this = this;
        var componentDeps = this.getDeps(this.component);
        console.log('deps', componentDeps);
        console.log('constructor', this.component.toString());
        console.log('component', this.component);
        var diParams = componentDeps.map(function (dep) { return _this.component[dep]; });
        var componentMeta = {
            selector: 'templatedComponent',
            template: this.template,
        };
        var TemplatedComponent = (function (_super) {
            __extends(TemplatedComponent, _super);
            function TemplatedComponent() {
                _super.call(this, diParams);
            }
            TemplatedComponent = __decorate([
                core_1.Component(componentMeta), 
                __metadata('design:paramtypes', [])
            ], TemplatedComponent);
            return TemplatedComponent;
        }(this.component));
        var componentInstance = new this.component(diParams);
        var componentKeys = Object.keys(componentInstance);
        componentKeys.map(function (key) { return TemplatedComponent[key] = componentInstance[key]; });
        return TemplatedComponent;
    };
    TemplationComponent.prototype.returnTemplationModule = function (_a) {
        var templatedComponent = _a.templatedComponent;
        var dynamicImports = this.imports;
        var TemplationModule = (function () {
            function TemplationModule() {
            }
            TemplationModule = __decorate([
                core_1.NgModule({
                    imports: dynamicImports,
                    declarations: [templatedComponent]
                }), 
                __metadata('design:paramtypes', [])
            ], TemplationModule);
            return TemplationModule;
        }());
        return TemplationModule;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], TemplationComponent.prototype, "imports", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], TemplationComponent.prototype, "template", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], TemplationComponent.prototype, "component", void 0);
    TemplationComponent = __decorate([
        core_1.Component({
            selector: 'templation',
            template: "<div></div>"
        }), 
        __metadata('design:paramtypes', [core_1.ViewContainerRef, core_1.ComponentFactoryResolver, core_1.Compiler])
    ], TemplationComponent);
    return TemplationComponent;
}());
exports.TemplationComponent = TemplationComponent;
//# sourceMappingURL=templation.component.js.map